Evas 1.7.9

Changes since Evas 1.7.9:
-------------------------
Fixes:
   * Evas textblock: Fixed order of tags inserted with markup_app/prepend.
   * Evas textblock: Fixed wrapping of lines ending with whites.

Changes since Evas 1.7.8:
-------------------------

Fixes:
   * Evas textblock: Fixed issue when parsing formats with quotes.
   * Evas textblock: Make the ellipsis format the same as the surrounding.
   * evas/wayland_egl: Skip makecurrent if re->win is NULL.
   * Evas textblock: Added proper size adjustments for "high" shaped texts.
   * Evas bidi: Fixed a bug causing BiDi not to work in some cases.
   * Evas textblock: fixed an issue with markup_get and markup_to_utf8 behaving differently (markup_get was misbehaving).
   * evas/wayland_egl: Do not create a new surface if we already have one.
   * Fixed the textblock format to be drawn according to the glyph's horizontal advance width.

Evas 1.7.8

Changes since Evas 1.7.7:
-------------------------

Fixes:
   * Correctly detect if a loader support asynchronous preloading.
   * Fix memory leak in evas textgrid
   * Evas: Fix evas_common_convert_yuv_42* functions to actually return the converted data.

Evas 1.7.7

Changes since Evas 1.7.6:
-------------------------

Fixes:
   * Fix over redrawing of Evas_Map when applied on smart object.
   * Evas font: Fix a bug with cluster size calculation with texts ending
   with ligatures.
   * Evas map: don't be crashed even if image size is 0.
   * Evas: Don't update evas update area by the clipper if the image obj visible is changed.
   * Evas textblock: Fixed a bug with deletion of ranges that end just before a visual format.
   * Evas: If an object goes to be hidden without replacing the cur/prev state info, the object context can be corrupted at the next show time. Now it replaces the cur/prev in that rare case.
   * Fix recursive proxy image rendering to just render black
   * Evas text: Fixed line size calculation when using multiple fonts.
   * Revert "Fix memory usage spike when rotating with the software_x11 engine."

Evas 1.7.6

Changes since Evas 1.7.5:
-------------------------

Fixes:
    * Fix SIGFPE in evas map update if image is 0.
    * Evas textblock: Fixed issue and simplified cursor_geometry_get.
    * Evas text: Fixed issue with horiz advance.
    * Evas text utils: Fixed issue with no-harfbuzz bidi.
    * Fixed pixman surface alloc where allocated and image size differ.
    * Stop initializing and shutting Fontconfig down
    * Evas textblock: Fixed a selection issue with different scripts and bidi.
    * Fix memory usage spike when rotating with the software_x11 engine.
    * Fix bmp portability issue on some 64bits system.
    * Fix textgrid portability issue on some 64bits system.
    * Evas text: Fixed bug with the text object direction detection.
    * Evas font: Fixed font run detection for specific cases with 2 different fonts in the middle of a run.
    * Evas cache: remove the freed worker from the pthread worker list when it's failed to create a new thread so as not to access it if a thread is working newly.
    * Fix evas word start/end find in textblock to be consistent with other toolkit logic on the matter
    * Fix crash in Evas Buffer engine when using output with no alpha.
    * Evas textblock: Fixed line size calculation when using multiple fonts.

Changes since Evas 1.7.5:
-------------------------

Fixes:
   * Fix SIGFPE in evas map update if image is 0.
   * Evas textblock: Fixed issue and simplified cursor_geometry_get.
   * Evas text: Fixed issue with horiz advance.
   * Evas text utils: Fixed issue with no-harfbuzz bidi.
   * Fixed pixman surface alloc where allocated and image size differ.
   * Stop initializing and shutting Fontconfig down
   * Evas textblock: Fixed a selection issue with different scripts and bidi.
   * Fix memory usage spike when rotating with the software_x11 engine.
   * Fix bmp portability issue on some 64bits system.
   * Fix textgrid portability issue on some 64bits system.
   * Evas text: Fixed bug with the text object direction detection.
   * Evas font: Fixed font run detection for specific cases with 2 different fonts in the middle of a run.
   * Evas cache: remove the freed worker from the pthread worker list when it's failed to create a new thread so as not to access it if a thread is working newly.
   * Fix evas word start/end find in textblock to be consistent with other toolkit logic on the matter
   * Fix crash in Evas Buffer engine when using output with no alpha.
   * Evas font: If OS/2 table is available and the font is demi-bold, don't do runtime emboldment.
   * Fix build of Evas XCB backend.
   * Fix evas bmp loader code which deal with image size.
   * Fix not up to date clip cache for Evas_Object_Text.
   * Evas texblock: Fixed a bug with breaking after format items.
   * Evas textblock: Fixed issue with line height when breaking on a format.
   * Evas: add pixels_alpha_get to evas engine.

Changes since Evas 1.7.4:
-------------------------

   * Fix mask write lines to not choose too small segments

Changes since Evas 1.7.3:
-------------------------

Fixes:
   * Fix the gl line incorrect position drawing.
   * Fix uninitialized data in Evas_Smart initialization code.
   * Fix potential segv in software engine native_set call.
   * Fix uninitialized data in OpenGL engine native_set call.
   * Fix crash when precise_is_inside is set on an image, and events are generated from it.
   * Properly close async pipe fd on exec.
   * Fix the line drawing clipping problem on arm gl driver.
   * Fix big rendering/conversion problem in kvm/qemu 24bpp.
   * Fix Evas RGBA_Image->flags.loaded for copied images. 
   * Fix evas_object_image_is_inside()
   * Fix small memory leak in evas_bidi_utils error path
    
Changes since Evas 1.7.2
-------------------------

Fixes:
   * Fixed evas_object_box to reset size_hint_min to zero when no child.
   * Don't leak fd on exec.

Changes since Evas 1.7.1
-------------------------

Fixes:
   * Fix evas textblock tag parser to respect escaped spaces and escaped single quotes
   * Fixed longstanding memset bug in evas box.
   * Fixed GLX native surface handling (fixes new mesa+intel comp bug).
   * Fixed textblock textprop leak.
    
Changes since Evas 1.7.0:
-------------------------

Improvements:
   * make xpm loader faster (from O(N) to O(log(N))).

Fixes:
   * Fix EGL/GLES dest alpha rendering bug (no rendering).
   * Fix evas_object_image_alpha_set when image data not loaded yet.
   * Fix map surface leak.
   * Fix native surface set to null crash bug in gl engine.
   * Fix font sizing issue with some rare sizes and fonts when rounding wrong.
   * Fix software line drawing c fallback code.
   * Update move event when object freeze event is off.
   * coordinate compute bug for Evas GL direct rendering.
    
Evas 1.7.0

Changes since Evas 1.2.0:
-------------------------

Additions:

   * Textgrid object.
   * Evas_Smart_Interface type, which brings simple interfaces support to smart objects.

Improvements:
   * Lock less font rendering.
   * Reduce cost of propagating event by limiting the object we explore by using a bouncing box.
   * Don't wake up prepare thread if there is nothing to prepare.
   * Limit the updated region to fit in CPU cache for Pipe rendering.
   * Cache convertion from Evas_Map to RGBA_Map.
   * evas_object_smart_members_get() now returns NULL on non-smart objects.
   * Pipeline rendering use prepare stage more extensively.
   * Properly warn when user try to link object from different canvas.

Fixes:
   * Add missing files in the tarball.
   * Add svg rendering with Esvg
   * Don't accept broken map.
   * Fix garbage left by mapped smart object when they fly away from the canvas.
   * Fix map life cycle.
   * Don't crash when calling evas_object_smart_type_check without type.
   * Handle proxy with the right context.
   * Force proxied object to stay active to keep track of change in them.
   * Fix evas_gl's internal resource surface bug when evas' window is deleted/recreated.
   * Fix evas_gl current_context update issue when evas_gl context is deleted.

Removal:
   * Remove EVAS_FRAME_QUEUING, EVAS_SLI, METRIC_CACHE and WORD_CACHE.
   * Remove librsvg svg loader (If you want to use it, use the evas_generic_loader variant).
   * Remove software DirectDraw 16 bits engine
   * Pipe rendering now need a patch to be turned on.

Evas 1.2.0

Changes since Evas 1.1.0:
-------------------------

Additions:

   * Textblock now supports self-closing tags, i.e <br/>. Those should be used instead of the old <br> way.
   * Shm engine for drawing in Wayland.
   * evas_object_smart_callback_del_full API.
   * Add double buffer support to the buffer engine.
   * evas_textblock_cursor_word_start/end.
   * evas_textblock_text_utf8_to_markup.
   * textblock b and i tags able to be overriden by style.
   * new api to set and get event flags
   * events just before/after canvas rendering
   * frame object set/get API's
   * evas_object_name_child_find.
   * evas_gl_config_new/free.
   * evas_object_smart_callback_del_full.
   * EVAS_OBJECT_POINTER_MODE_NOGRAB_NO_REPEAT_UPDOWN.
   * EVAS_GL_OPTIONS_DIRECT.
   * evas_object_textblock_style_user_pop/push.
   * evas_object_ref_get
   * Evas_GL_Multisample_Bits MSAA surface config option for supported devices.

Fixes:

   * don't enable SSE3 if immintrin.h isn't there.
   * clip bounds calculation rounding error.
   * grab count negative values with weird multi-finger press/release usage.
   * clip bug that shows up in buffer engine.
   * disabled buggy SSE3 routines.
   * repeat events passing between layers within the same object.
   * uninitialized value when running generic loader.
   * rounding of update regions in scaled image objects.
   * handling of layouts where weights have sub integer values.
   * gl engine cliupping bug when rendering maps to fbo's.
   * liblinebreak disabled compilation bug.
   * color multiplier staying set when rendering map.
   * shader binary now saves if shader dir exists already.

Improvements:

   * use Eina_File mmap for bmp, ico, pmaps, psd, wbmp and xpm file access.
   * textblock br and tab tags now default for newline and tab.
   * extended pixman routine support for most software rendering routines.
   * added tiled rotator for 32bit displays (faster).
   * work around nvidia driver spin-using-cpu and don't use glXWaitGL()
   * evasgl back-end for software using OSMesa.

Removal:

   * Software_SDL engine is gone, use buffer engine directly.

Evas 1.1.0

Changes since Evas 1.0.0:
-------------------------

Additions:

    * auto-align feature to textblock
    * mixedwrap wrap mode to textblock
    * harfbuzz support for shaping
    * WBMP loader
    * mirror mode for tables
    * proxy abilities to image objects to choose source ro mirror
    * speculative texture cache to the OpenGL engine to avoid texture uploads
    * newline policy setting API to textblock
    * evas_object_ref and evas_object_unref to defer object deletions
    * ICO loader
    * evas_object_image_memfile_set to load images from memory
    * vertical alignment to textblock
    * more shadow directions for text rendering
    * runtime italicizing and boldening of fonts that don't have their own
    * more bidi API support
    * PSD loader
    * generic external-process loader for thins like xcf, pdf, video, ps
    * password mode to textblock
    * GL shader disk cache to avoid re-compilng on start
    * evas_textblock_node_format_list_get. API
    * smart class usage count get API
    * grid layout smart object and API
    * evas_event_thaw_eval to help evaluate state and events on event thaw
    * textblock support for numeric escapes like "&#x3c;" in markup
    * evas_object_image_extension_can_load_get API
    * evas_object_image_extension_can_load_fast_get API
    * evas_object_image_load_orientation_get API
    * evas_object_image_load_orientation_set API
    * feature to allow tables to repack the same object without error
    * API to get child packing from table
    * is_inside implementation for polygon objects
    * out-of-order open/close tag support in textblock markup
    * support for quoted parameters in tags in textblock markup
    * font_weight and font_style formats
    * font_width font format
    * markup tag to specify language
    * evas_textblock_cursor_range_formats_get API
    * evas_textblock_cursor_visible_range_get API
    * callback prioritization support
    * YUV 601 input support for evas_object_image_data_convert
    * NV12 colorspace for evas image objects
    * MT12 colorspace for evas image objects
    * underline dashing support to textblock
    * API to get largest image size
    * GL Cocoa engine
    * Evas GL support in software backend through OSMesa
    * API to new/free Evas_GL_Config rather than user declaring it
    * Evas GL Direct rendering option hint to allow rendering to evas' window when possible

Fixes:

    * cursor and selection handling with bidi text
    * many general bid issues with text
    * free bug in key grabs
    * bug when images are scaled to massive sizes (like 1 billion pixels)
    * BMP decode for have more pixels per line than the image does
    * font string parsing bug if font element is too long
    * crash bug in argb8888 to a8 conversion
    * textblock bug with cursors in empty textblocks
    * bug in smart calc array where some objects would be skipped
    * static linking of BMP and TGA loaders
    * bug when GL viewport was set with a NULL context
    * bug when looking for vsync API due to SGI vs EXT differences
    * bug in evas_object_del where DEL callback happened before HIDE
    * yinversion bug on some GL surfaces
    * BMP loader to handle alpha BMPS as solid where all alpha values are 0
    * clipping with evas map issues
    * bug where wrong call was used for freeing a mempool object
    * static linking of GL engine
    * GL engine to handle if someone uses GL contexts outside of evas
    * bug in evas_object_textblock_text_markup_prepend that broke cursors
    * lack of calling pre/post swap callbacks when using OpenGL-ES2
    * some crashes with load options scaling of SVGs in 2nd pass decode
    * segfault with evas_textblock_cursor_content_get
    * libjpeg 8 compilation support on windows
    * evas table to handle weighting correctly and expansion
    * evas table to allow fractional weights, not just 0/1
    * glyph search bug causing inconsitent return values in some cases
    * compile when --disable-async-preload is used
    * callback counter bug
    * grab count and hide bug
    * infinite loop bug when re-inserting objects during pre-render calc
    * evas_object_image_data_convert
    * TGA loader detects false positives less and handles alpha TGAs better
    * repeat event flag not inherited from parent smart like pass events

Improvements:

    * pre-render speed for rectangles if they are invisible
    * code of textblock and font engine
    * textblock layout speed
    * speed and memory usage of textblock
    * cache handler to also use file size, mode and sub-second timestamp
    * textblock to re-layout only paragraphs that have changed
    * homogenous table layout alignment and sizing
    * textblock linebreaking by using liblinebreak
    * image loader to drop out instantly if image file is a directory
    * object allocation to use mempools
    * font engine to use string objects not strings for caching purposes
    * text to display missing unicode char instead of missing glyphs
    * internal file code to use eina_file more
    * jpeg loader to use eina_file
    * jpeg encode and decode quality improved at expense of speed

Removals:

    * removed quartz, cairo, qtopia and xrender engines. dead.
